@page "/Lists/AllElements"
@inject Microsoft.Extensions.Localization.IStringLocalizer<App> Localize
@inject DataService DS
@inject SessionData SD
@inject IJSRuntime JSRuntime
@using BioMap
@inherits ProtectedPage

<div class="box">
  <div class="row header">
    <FilterSettings FilteringTarget="@Filters.FilteringTargetEnum.Elements" />
  </div>
  <div class="row content">
    <h1>@Localize["All Elements"]</h1>
    <p>Anzahl Elemente: @Elements.Length</p>
    <Table Class="table-striped table-sm">
      <TableHeader>
        <TableRow>
          <TableHeaderCell>
            @Localize["Classification"]
          </TableHeaderCell>
          <TableHeaderCell Style="width:18%;">
            @Localize["Details"]
          </TableHeaderCell>
          <TableHeaderCell Style="width:15%;">
            @Localize["Time"]
          </TableHeaderCell>
          <TableHeaderCell Style="width:25%;">
            @Localize["Name"]
          </TableHeaderCell>
          <TableHeaderCell>
            @Localize["User"]
          </TableHeaderCell>
        </TableRow>
      </TableHeader>
      <TableBody>
        @foreach (var el in Elements) {
          <TableRow>
            <TableRowCell>
              @Localize[@el.GetClassName()]
            </TableRowCell>
            <TableRowCell>
              @el.GetDetails()
            </TableRowCell>
            <TableRowCell>
              @el.GetIsoDateTime()
            </TableRowCell>
            <TableRowCell>
              <a href="javascript:void(0);" @onclick="()=>OnSelectClick(el)">@el.ElementName</a>
            </TableRowCell>
            <TableRowCell>
              @el.ElementProp.UploadInfo.UserId
              <Button Float="Float.End" Color="Color.Light" Disabled="!SD.CurrentUser.MayDeleteElement(el)" Clicked="@((e)=>{ DeleteElement(el); })">
                <Icon Name="IconName.Delete"></Icon>
              </Button>
            </TableRowCell>
          </TableRow>
        }
      </TableBody>
    </Table>
    @if (SD.CurrentUser.Level >= 500) {
      <Button Color="Color.Primary" Clicked="@(async (e)=>DownloadCsv_Clicked())">Download CSV</Button>
    }
  </div>
</div>

<PhotoPopup @ref="PhotoPopup1" ElementDeleted="@(() => this.OnElementDeleted())" />

@code {
  private Element[] Elements = new Element[0];
  private PhotoPopup PhotoPopup1;
  protected override void OnInitialized() {
    base.OnInitialized();
    this.SD.Filters.FilterChanged += this.Filters_FilterChanged;
    this.RefreshData();
  }
  protected override async Task OnAfterLeavePage()
  {
    this.SD.Filters.FilterChanged -= this.Filters_FilterChanged;
  }
  private void Filters_FilterChanged(object sender, EventArgs e)
  {
    this.RefreshData();
    base.InvokeAsync(this.StateHasChanged);
  }
  private void RefreshData()
  {
    this.Elements = DS.GetElements(SD,SD.Filters,"","elements.creationtime DESC");
  }
  private void OnSelectClick(Element el) {
    this.PhotoPopup1.Show(el);
  }
  private void DeleteElement(Element el) {
    DS.DeleteElement(SD,el);
    DS.AddLogEntry(SD,"Deleted element " + el.ElementName);
    RefreshData();
    this.StateHasChanged();
  }
  private async void DownloadCsv_Clicked() {
    var sep = "\t";
    var csv = new System.Text.StringBuilder();
    csv.Append("ElementName" + sep + "TimeStamp" + sep + "Class" + sep + "GpsLat" + sep + "GpsLng" + sep + "Place" + "\n");
    foreach (var el in DS.GetElements(SD,SD.Filters)) {
      var placeName = el.GetPlaceName();
      csv.Append('"' + el.ElementName + '"');
      csv.Append(sep + '"' + el.GetIsoDateTime() + '"');
      csv.Append(sep + '"' + el.GetClassName() + '"');
      csv.Append(sep + ConvInvar.ToDecimalString(el.ElementProp.MarkerInfo.position.lat,12));
      csv.Append(sep + ConvInvar.ToDecimalString(el.ElementProp.MarkerInfo.position.lng,12));
      csv.Append(sep + placeName);
      csv.Append('\n');
    }
    await JSRuntime.InvokeVoidAsync("DownloadTextFile","AllElements.csv",csv.ToString());
  }
  public void OnElementDeleted() {
    this.RefreshData();
    this.StateHasChanged();
  }
}
